#include "rslib.h"
#pragma hdrstop


#define DEFAULTCHAR ((int)'.')

int GIFFont::Length(const char* str)
{
if (!str) return 0;
int i,n;
int l=0;
for (i=0;str[i];i++) {
	if ((n=lookup[(int)str[i]])==-1) {
		if ((n=lookup[DEFAULTCHAR])==-1) continue;
	}
	l+=symbols[n].width;
}
return l;
}

GIFFont::GIFFont(const char* n, int s, const char* m, int* l,pixsymbol*x)
{
	name=n;
	size=s;
	map=m;
	lookup=l;
	symbols=x;

  for (size_t i=0; i < 256; i++)
  {
   lookup[i] = -1;
  }

  for (size_t i=0; map[i]; i++)
  {
   lookup[(size_t)map[i]] = i;
  }
}

int h9lookup[]= {
-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1
,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1
,27,28,29,30,31,32,33,34,35,36,37,38,39,40,41,42
,43,44,45,46,47,48,49,50,51,52,53,54,55,56,57,58
,59,60,61,62,63,64,65,66,67,68,69,70,71,72,73,74
,75,76,77,78,79,80,81,82,83,84,85,86,87,88,89,90
,91,92,93,94,0,1,2,3,4,5,6,7,8,9,10,11
,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,-1
,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1
,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1
,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1
,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1
,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1
,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1
,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1
,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1};

GIFFont::pixsymbol h9symbols[]=
//symbols
{
{7,7,0,
	".XXXX.."
	"XX..XX."
	"....XX."
	".XXXXX."
	"XX..XX."
	"XX..XX."
	".XXX.XX"},
{9,7,0,
	"XX....."
	"XX....."
	"XX.XX.."
	"XXX.XX."
	"XX..XX."
	"XX..XX."
	"XX..XX."
	"XXX.XX."
	"XX.XX.."},
{7,7,0,
	".XXXX.."
	"XX..XX."
	"XX....."
	"XX....."
	"XX....."
	"XX..XX."
	".XXXX.."},
{9,7,0,
	"....XX."
	"....XX."
	".XX.XX."
	"XX.XXX."
	"XX..XX."
	"XX..XX."
	"XX..XX."
	"XX.XXX."
	".XX.XX."},
{7,7,0,
	".XXXX.."
	"XX..XX."
	"XX..XX."
	"XXXXXX."
	"XX....."
	"XX..XX."
	".XXXX.."},
{9,5,0,
	"..XXX"
	".XX.."
	"XXXX."
	".XX.."
	".XX.."
	".XX.."
	".XX.."
	".XX.."
	".XX.."},
{10,7,3,
	".XX.XX."
	"XX.XXX."
	"XX..XX."
	"XX..XX."
	"XX..XX."
	"XX.XXX."
	".XX.XX."
	"....XX."
	"XX..XX."
	".XXXX.."},
{9,7,0,
	"XX....."
	"XX....."
	"XX.XX.."
	"XXX.XX."
	"XX..XX."
	"XX..XX."
	"XX..XX."
	"XX..XX."
	"XX..XX."},
{9,3,0,
	"XX."
	"..."
	"XX."
	"XX."
	"XX."
	"XX."
	"XX."
	"XX."
	"XX."},
{12,3,3,
	"XX."
	"..."
	"XX."
	"XX."
	"XX."
	"XX."
	"XX."
	"XX."
	"XX."
	"XX."
	"XX."
	"X.."},
{9,7,0,
	"XX....."
	"XX....."
	"XX..XX."
	"XX.XX.."
	"XXXX..."
	"XXXX..."
	"XX.XX.."
	"XX..XX."
	"XX...XX"},
{9,3,0,
	"XX."
	"XX."
	"XX."
	"XX."
	"XX."
	"XX."
	"XX."
	"XX."
	"XX."},
{7,11,0,
	"X.XXX.XXX.."
	"XX..XX..XX."
	"XX..XX..XX."
	"XX..XX..XX."
	"XX..XX..XX."
	"XX..XX..XX."
	"XX..XX..XX."},
{7,7,0,
	"XX.XX.."
	"XXX.XX."
	"XX..XX."
	"XX..XX."
	"XX..XX."
	"XX..XX."
	"XX..XX."},
{7,7,0,
	".XXXX.."
	"XX..XX."
	"XX..XX."
	"XX..XX."
	"XX..XX."
	"XX..XX."
	".XXXX.."},
{10,7,3,
	"XX.XX.."
	"XXX.XX."
	"XX..XX."
	"XX..XX."
	"XX..XX."
	"XXX.XX."
	"XX.XX.."
	"XX....."
	"XX....."
	"XX....."},
{10,7,3,
	".XXX.X."
	"XX.XXX."
	"XX..XX."
	"XX..XX."
	"XX..XX."
	"XX.XXX."
	".XX.XX."
	"....XX."
	"....XX."
	"....XX."},
{7,5,0,
	"XX.XX"
	"XXXXX"
	"XXX.."
	"XX..."
	"XX..."
	"XX..."
	"XX..."},
{7,7,0,
	".XXXX.."
	"XX..XX."
	"XXX...."
	"..XXX.."
	"...XXX."
	"XX..XX."
	".XXXX.."},
{9,5,0,
	".XX.."
	".XX.."
	"XXXX."
	".XX.."
	".XX.."
	".XX.."
	".XX.."
	".XX.X"
	"..XX."},
{7,7,0,
	"XX..XX."
	"XX..XX."
	"XX..XX."
	"XX..XX."
	"XX..XX."
	"XX.XXX."
	".XX.XX."},
{7,8,0,
	"XX...XX."
	"XX...XX."
	".XX.XX.."
	".XX.XX.."
	"..XXX..."
	"..XXX..."
	"...X...."},
{7,11,0,
	"XX..XX..XX."
	"XX..XX..XX."
	".XX.XX.XX.."
	".XX.XX.XX.."
	".XX.XX.XX.."
	"..XX..XX..."
	"..XX..XX..."},
{7,7,0,
	"XX..XX."
	"XX..XX."
	".XXXX.."
	"..XX..."
	".XXXX.."
	"XX..XX."
	"XX..XX."},
{10,8,3,
	"XX...XX."
	"XX...XX."
	".XX.XX.."
	".XX.XX.."
	"..XXX..."
	"..XXX..."
	"...XX..."
	"...X...."
	"..XX...."
	".XX....."},
{7,6,0,
	"XXXXX."
	"...XX."
	"..XX.."
	"..X..."
	".XX..."
	"XX...."
	"XXXXX."},
{12,5,3,
	"..XX."
	".XX.."
	".XX.."
	".XX.."
	".XX.."
	"XX..."
	".XX.."
	".XX.."
	".XX.."
	".XX.."
	".XX.."
	"..XX."},
{12,4,3,
	".XX."
	".XX."
	".XX."
	".XX."
	".XX."
	".XX."
	".XX."
	".XX."
	".XX."
	".XX."
	".XX."
	".XX."},
{12,5,3,
	"XX..."
	".XX.."
	".XX.."
	".XX.."
	".XX.."
	"..XX."
	".XX.."
	".XX.."
	".XX.."
	".XX.."
	".XX.."
	"XX..."},
{2,7,-3,
	".XXX.XX"
	"XX.XXX."},
{1,4,0,
	"...."},
{9,4,0,
	".XX."
	".XX."
	".XX."
	".XX."
	".XX."
	".X.."
	"...."
	".XX."
	".XX."},
{3,5,-6,
	".X.X."
	".X.X."
	".X.X."},
{8,8,0,
	"...X.X.."
	"...X.X.."
	".XXXXXX."
	"..X.X..."
	"..X.X..."
	"XXXXXX.."
	".X.X...."
	".X.X...."},
{11,7,2,
	"...X..."
	".XXXX.."
	"XX.X.X."
	"XX.X..."
	".XXXX.."
	"...XXX."
	"X..X.X."
	"XX.X.X."
	".XXXX.."
	"...X..."
	"...X..."},
{9,12,0,
	".XXX...X...."
	"XX.XX.XX...."
	"XX.XX.X....."
	".XXX.X......"
	".....X......"
	"....X..XXX.."
	"....X.XX.XX."
	"...XX.XX.XX."
	"...X...XXX.."},
{9,9,0,
	"..XXX...."
	".XX.XX..."
	".XX.XX..."
	"..XXX...."
	".XXXX..X."
	"XX..XXXX."
	"XX...XX.."
	"XX..XXXX."
	".XXXX..XX"},
{3,4,-6,
	".XX."
	"..X."
	".X.."},
{12,6,3,
	"...XX."
	"..XX.."
	"..XX.."
	".XX..."
	".XX..."
	".XX..."
	".XX..."
	".XX..."
	".XX..."
	"..XX.."
	"..XX.."
	"...XX."},
{12,6,3,
	".XX..."
	"..XX.."
	"..XX.."
	"...XX."
	"...XX."
	"...XX."
	"...XX."
	"...XX."
	"...XX."
	"..XX.."
	"..XX.."
	".XX..."},
{4,6,-5,
	"..X..."
	"XXXXX."
	".XXX.."
	".X.X.."},
{5,7,-1,
	"..XX..."
	"..XX..."
	"XXXXXX."
	"..XX..."
	"..XX..."},
{4,4,2,
	".XX."
	".XX."
	"..X."
	".X.."},
{1,8,-3,
	".XXXXX.."},
{2,4,0,
	".XX."
	".XX."},
{9,4,0,
	"..XX"
	"..XX"
	"..X."
	".XX."
	".XX."
	".X.."
	".X.."
	"XX.."
	"XX.."},
{9,7,0,
	".XXXX.."
	"XX..XX."
	"XX..XX."
	"XX..XX."
	"XX..XX."
	"XX..XX."
	"XX..XX."
	"XX..XX."
	".XXXX.."},
{9,7,0,
	"..XX..."
	"XXXX..."
	"..XX..."
	"..XX..."
	"..XX..."
	"..XX..."
	"..XX..."
	"..XX..."
	"..XX..."},
{9,7,0,
	".XXXX.."
	"XX..XX."
	"....XX."
	"...XX.."
	"..XX..."
	".XX...."
	"XX....."
	"XX....."
	"XXXXXX."},
{9,7,0,
	".XXXX.."
	"XX..XX."
	"....XX."
	"..XXX.."
	"....XX."
	"....XX."
	"....XX."
	"XX..XX."
	".XXXX.."},
{9,7,0,
	"....XX."
	"...XXX."
	"..X.XX."
	"..X.XX."
	".X..XX."
	"X...XX."
	"XXXXXXX"
	"....XX."
	"....XX."},
{9,7,0,
	".XXXXX."
	".XX...."
	"XX....."
	"XXXXX.."
	"....XX."
	"....XX."
	"XX..XX."
	"XX..XX."
	".XXXX.."},
{9,7,0,
	".XXXX.."
	"XX..XX."
	"XX....."
	"XX....."
	"XXXXX.."
	"XX..XX."
	"XX..XX."
	"XX..XX."
	".XXXX.."},
{9,7,0,
	"XXXXXX."
	"....XX."
	"...XX.."
	"...XX.."
	"..XX..."
	"..XX..."
	"..XX..."
	".XX...."
	".XX...."},
{9,7,0,
	".XXXX.."
	"XX..XX."
	"XX..XX."
	".XXXX.."
	"XX..XX."
	"XX..XX."
	"XX..XX."
	"XX..XX."
	".XXXX.."},
{9,7,0,
	".XXXX.."
	"XX..XX."
	"XX..XX."
	"XX..XX."
	".XXXXX."
	"....XX."
	"....XX."
	"XX..XX."
	".XXXX.."},
{7,4,0,
	".XX."
	".XX."
	"...."
	"...."
	"...."
	".XX."
	".XX."},
{9,4,2,
	".XX."
	".XX."
	"...."
	"...."
	"...."
	".XX."
	".XX."
	"..X."
	".X.."},
{5,7,-1,
	"....XX."
	"..XXX.."
	".XX...."
	"..XXX.."
	"....XX."},
{3,7,-2,
	"XXXXXX."
	"......."
	"XXXXXX."},
{5,7,-1,
	".XX...."
	"..XXX.."
	"....XX."
	"..XXX.."
	".XX...."},
{9,8,0,
	"..XXXX.."
	".XX..XX."
	".XX..XX."
	"....XX.."
	"...XX..."
	"...XX..."
	"........"
	"...XX..."
	"...XX..."},
{10,12,1,
	"....XXXXX..."
	"..XX.....X.."
	"..X.......X."
	".X...XX.X.X."
	".X..X..X..X."
	".X.X...X..X."
	".X.X..XX.X.."
	".X..XX.XX..."
	"..X........."
	"...XXXXX...."},
{9,8,0,
	"...XX..."
	"..XXXX.."
	"..X..X.."
	".XX..XX."
	".XX..XX."
	".XXXXXX."
	"XX....XX"
	"XX....XX"
	"XX....XX"},
{9,9,0,
	".XXXXXX.."
	".XX...XX."
	".XX...XX."
	".XX...XX."
	".XXXXXX.."
	".XX...XX."
	".XX...XX."
	".XX...XX."
	".XXXXXX.."},
{9,8,0,
	"...XXXX."
	"..XX..XX"
	".XX....."
	".XX....."
	".XX....."
	".XX....."
	".XX....."
	"..XX..XX"
	"...XXXX."},
{9,9,0,
	".XXXXX..."
	".XX..XX.."
	".XX...XX."
	".XX...XX."
	".XX...XX."
	".XX...XX."
	".XX...XX."
	".XX..XX.."
	".XXXXX..."},
{9,8,0,
	".XXXXXX."
	".XX....."
	".XX....."
	".XX....."
	".XXXXXX."
	".XX....."
	".XX....."
	".XX....."
	".XXXXXX."},
{9,7,0,
	".XXXXXX"
	".XX...."
	".XX...."
	".XX...."
	".XXXXX."
	".XX...."
	".XX...."
	".XX...."
	".XX...."},
{9,10,0,
	"...XXXXX.."
	"..XX...XX."
	".XX......."
	".XX......."
	".XX..XXXX."
	".XX....XX."
	".XX....XX."
	"..XX...XX."
	"...XXXX.X."},
{9,9,0,
	".XX...XX."
	".XX...XX."
	".XX...XX."
	".XX...XX."
	".XXXXXXX."
	".XX...XX."
	".XX...XX."
	".XX...XX."
	".XX...XX."},
{9,4,0,
	".XX."
	".XX."
	".XX."
	".XX."
	".XX."
	".XX."
	".XX."
	".XX."
	".XX."},
{9,7,0,
	"....XX."
	"....XX."
	"....XX."
	"....XX."
	"....XX."
	"....XX."
	"XX..XX."
	"XX..XX."
	".XXXX.."},
{9,9,0,
	".XX...XX."
	".XX..XX.."
	".XX.XX..."
	".XXXX...."
	".XXXX...."
	".XX.XX..."
	".XX..XX.."
	".XX...XX."
	".XX....XX"},
{9,7,0,
	".XX...."
	".XX...."
	".XX...."
	".XX...."
	".XX...."
	".XX...."
	".XX...."
	".XX...."
	".XXXXXX"},
{9,11,0,
	".XX.....XX."
	".XX.....XX."
	".XXX...XXX."
	".XXX...XXX."
	".XXXX.XXXX."
	".XX.X.X.XX."
	".XX.XXX.XX."
	".XX..X..XX."
	".XX..X..XX."},
{9,9,0,
	".XX...XX."
	".XXX..XX."
	".XXX..XX."
	".XX.X.XX."
	".XX.X.XX."
	".XX..XXX."
	".XX..XXX."
	".XX...XX."
	".XX...XX."},
{9,10,0,
	"...XXXX..."
	"..XX..XX.."
	".XX....XX."
	".XX....XX."
	".XX....XX."
	".XX....XX."
	".XX....XX."
	"..XX..XX.."
	"...XXXX..."},
{9,8,0,
	".XXXXXX."
	".XX...XX"
	".XX...XX"
	".XX...XX"
	".XXXXXX."
	".XX....."
	".XX....."
	".XX....."
	".XX....."},
{9,10,0,
	"...XXXX..."
	"..XX..XX.."
	".XX....XX."
	".XX....XX."
	".XX....XX."
	".XX..X.XX."
	".XX..XXXX."
	"..XX..XX.."
	"...XXXXXX."},
{9,9,0,
	".XXXXXX.."
	".XX...XX."
	".XX...XX."
	".XX...XX."
	".XXXXXX.."
	".XX..XX.."
	".XX...XX."
	".XX...XX."
	".XX...XX."},
{9,9,0,
	"..XXXXX.."
	".XX...XX."
	".XX...XX."
	"..XXX...."
	"....XXX.."
	".....XXX."
	".XX...XX."
	".XX...XX."
	"..XXXXX.."},
{9,8,0,
	"XXXXXXXX"
	"...XX..."
	"...XX..."
	"...XX..."
	"...XX..."
	"...XX..."
	"...XX..."
	"...XX..."
	"...XX..."},
{9,9,0,
	".XX...XX."
	".XX...XX."
	".XX...XX."
	".XX...XX."
	".XX...XX."
	".XX...XX."
	".XX...XX."
	"..XX.XX.."
	"..XXXXX.."},
{9,8,0,
	"XX....XX"
	"XX....XX"
	".XX..XX."
	".XX..XX."
	".XX..XX."
	"..X..X.."
	"..XXXX.."
	"...XX..."
	"...XX..."},
{9,10,0,
	"XX..XX..XX"
	"XX..XX..XX"
	"XX..XX..XX"
	".X..XX..X."
	".XX.XX.XX."
	".XX.XX.XX."
	"..XX..XX.."
	"..XX..XX.."
	"..XX..XX.."},
{9,8,0,
	"XX....XX"
	"XX....XX"
	".XX..XX."
	"..XXXX.."
	"...XX..."
	"..XXXX.."
	".XX..XX."
	"XX....XX"
	"XX....XX"},
{9,8,0,
	"XX....XX"
	"XX....XX"
	".XX..XX."
	".XX..XX."
	"..XXXX.."
	"...XX..."
	"...XX..."
	"...XX..."
	"...XX..."},
{9,7,0,
	"XXXXXXX"
	".....XX"
	"....XX."
	"...XX.."
	"..XX..."
	"..XX..."
	".XX...."
	"XX....."
	"XXXXXXX"},
{12,4,3,
	".XXX"
	".XX."
	".XX."
	".XX."
	".XX."
	".XX."
	".XX."
	".XX."
	".XX."
	".XX."
	".XX."
	".XXX"},
{9,4,0,
	"XX.."
	"XX.."
	".X.."
	".XX."
	".XX."
	"..X."
	"..X."
	"..XX"
	"..XX"},
{12,4,3,
	"XXX."
	".XX."
	".XX."
	".XX."
	".XX."
	".XX."
	".XX."
	".XX."
	".XX."
	".XX."
	".XX."
	"XXX."},
{4,7,-5,
	"...X..."
	"..XXX.."
	".XX.XX."
	"XX...XX"},
{1,7,3,
	"XXXXXXX"},
{3,4,-6,
	"..X."
	".X.."
	".XX."}};



GIFFont Font_Helvetica9("Helvetica",9,
"abcdefghijklmnopqrstuvwxyz{|}~ !\"#$%&,()*+'-./0123456789:;<=>?@ABCDEFGHIJKLMNOPQRSTUVWXYZ[\\]^_`",
h9lookup, h9symbols);
